<template>
  <puntos-venta-aprobados-geografia
    :loadingTitle="loadingTitle"
    :loadingContent="loadingContent"
    :titleNotFound="titleNotFound"
    :contentNotFound="contentNotFound"
    :data="data"
    @categoryClicked="categoryClicked"
  />
</template>
<script>
import PuntosVentaAprobadosGeografia from "@/views/secure/sistema-informacion/dashboards/v2/disciplinas/components/graficas/PuntosVentaAprobadosGeografia.vue";
import store from "@/store";
const axios = store.state.axiosApiLocal;
const serviceCommons = store.state.serviceCommons;
export default {
  name: "Component-No4PuntosVentaAprobadosGeografiaImpl",
  props: ["filters", "setFilters"],
  components: {
    PuntosVentaAprobadosGeografia,
  },
  data() {
    return {
      loadingTitle: true,
      loadingContent: true,
      titleNotFound: false,
      contentNotFound: false,
      data: {
        descripcion: null,
        color: serviceCommons.getColorVuetifyByName("grey lighten-1"),
        graficaLeyends: {
          titles: {
            left: "Escala puntos de venta",
            right: "Escala porcentaje",
          },
          categorys: {
            left: "Puntos de venta aprobados",
            right: "Porcentaje de puntos de venta",
          },
        },
        values: [],
      },
    };
  },
  watch: {
    filters(val) {
      this.getData();
    },
  },
  methods: {
    categoryClicked(data) {
      let filters = this.filters;
      filters.request.nivelCentroCostos = data.centroCostos;
      this.setFilters(filters);
    },
    getGrafica() {
      axios(
        "/sistema-informacion/tablero/graficas/v1/clave/generica-puntos-venta-aprobados-geografia"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            this.data = Object.assign(this.data, data.resultado);
          }
        })
        .catch((error) => {
          this.titleNotFound = true;
          console.log(error);
        })
        .finally(() => {
          this.loadingTitle = false;
        });
    },
    getData() {
      this.loadingContent = true;
      this.contentNotFound = false;
      axios
        .post(
          "/sistema-informacion/tablero/reportes/v1/disciplinas/" +
            this.filters.path.idDisciplina +
            "/generico/puntos-venta-aprobados-geografia/busquedas",
          this.filters.request
        )
        .then((response) => {
          let data = response.data;
          if (data) {
            let puntosVentaAprobadosGeografia =
              data.resultado.puntosVentaAprobadosGeografia;
            this.data.values = [];
            puntosVentaAprobadosGeografia.forEach((element) => {
              this.data.values.push({
                centroCostos: element.centroCostos,
                categoria: element.descripcion,
                valor: element.puntosVenta,
                calificacion: element.porcentaje,
              });
            });
          }
        })
        .catch((error) => {
          this.contentNotFound = true;
          console.log(error);
        })
        .finally(() => {
          this.loadingContent = false;
        });
    },
  },
  created() {
    this.getGrafica();
  },
};
</script>
